assert          = require('chai').assert
Datastore       = require 'stout-memory-datastore/Datastore'
SessionJanitor  = require '../../../job/SessionJanitor'
SessionProvider = require '../../../provider/SessionProvider'
Session         = require '../../../model/Session'
set             = require 'lodash/set'
sinon           = require 'sinon'



describe 'job/SessionJanitor', ->
  job = provider = null

  @slow(2000)

  insertSessions = (expired = 10, valid = 10) ->
    sessions = []
    for i in [0...expired]
      sessions.push new Session {expires: Date.now() - Math.random() * 1000}
    for i in [0...valid]
      sessions.push new Session
    provider.insert(sessions)

  beforeEach ->
    datastore = new Datastore
    Session.hasOne = []
    provider = new SessionProvider {model: Session, datastore}
    job = new SessionJanitor 0.1
    job.__provider = provider

  afterEach ->
    job.cancel()


  it 'removes expired sessions on each run', (done) ->
    testExpiredCount = (n) ->
      provider.getExpiredSessions(100).then (results) ->
        assert.lengthOf results, n
        if n is 40 then done()
      .catch done
    insertSessions(100).then ->
      setTimeout (-> testExpiredCount(40)), 300
    .catch done
    return
