assert          = require('chai').assert
Datastore       = require 'stout-memory-datastore/Datastore'
SessionProvider = require '../../../provider/SessionProvider'
Session         = require '../../../model/Session'
sinon           = require 'sinon'



describe 'provider/SessionProvider', ->
  provider = datastore = null

  @slow(2000)

  beforeEach ->
    datastore = new Datastore
    Session.hasOne = []
    provider = new SessionProvider {model: Session, datastore}

  insertSessions = (expired = 10, valid = 10) ->
    sessions = []
    for i in [0...expired]
      sessions.push new Session {expires: Date.now() - Math.random() * 1000}
    for i in [0...valid]
      sessions.push new Session
    provider.insert(sessions)



  describe '#getExpiredSessions()', ->

    it 'resolves to empty array when there are no expired sessions', ->
      provider.getExpiredSessions().then (sessions) ->
        assert.lengthOf sessions, 0

    it 'resolves to an array of expired sessions', ->
      insertSessions().then ->
        provider.getExpiredSessions().then (sessions) ->
          assert.lengthOf sessions, 10

    it 'can get a specified number of expired sessions', ->
      insertSessions(100).then ->
        provider.getExpiredSessions(72).then (sessions) ->
          assert.lengthOf sessions, 72


  describe '#deleteExpiredSessions()', ->

    it 'can get a specified number of expired sessions', ->
      insertSessions().then ->
        provider.deleteExpiredSessions(100).then (sessions) ->
          provider.getExpiredSessions().then (sessions) ->
            assert.lengthOf sessions, 0
