# # `test:unit:node`
#
# Runs unit tests in the locally installed and running NodeJS (or io.js)
# environment.

gulp    = require('gulp-help')(require 'gulp')
mocha   = require 'gulp-mocha'
targets = require '../helpers/targets'


module.exports = (config, options) ->

  name = 'unit'
  description = 'Run unit tests in NodeJS.'

  gulp.task name, description, ->

    if options.watch
      src = targets(config).concat("#{config.path.test}/**/*.test.js")
      gulp.watch src, [name]

    gulp.src "#{config.path.test}/**/*.test.js"
    .pipe mocha()
  , {
    options:
      'watch': 'Watch for changes and rerun unit tests.'
  }
